//+------------------------------------------------------------------+
//|                                           M5-M30-RSI Candles.mq4 |
//+------------------------------------------------------------------+
//---- indicator settings
#property  indicator_chart_window

#property indicator_buffers 4
#property indicator_color1 Lime//wicks
#property indicator_color2 Red//wicks
#property indicator_color3 Lime
#property indicator_color4 Red

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 3
#property indicator_width4 3

//---- indicator parameters
extern string     RSI_Candles              = "== TF 30Min RSI  ===";

extern int        Tf30_Rsi8_Per            = 8 ;
extern int        Tf30_Rsi4_Per            = 4 ;
extern int        Tf30_Rsi2_Per            = 2 ;

extern int BARS = 300;
extern string IIIIIIIIIIIIIIIIIIIIIIIII=">>> Candle/Wick Display Settings >>>>>>>>>>>>>>>>>";		 
extern int		BarWidth			= 1,
					CandleWidth		= 3;

//---- indicator buffers
double Bar1[],
		 Bar2[],
		 Candle1[],
		 Candle2[],
		 Candle3[],
		 Candle4[],
		 Candle5[],
		 Candle6[];
		 
int nDigits;		 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {


   IndicatorShortName("M5-M30-RSI Candles");
	IndicatorBuffers(4);
	
	SetIndexBuffer(0,Bar1);
	SetIndexBuffer(1,Bar2);
	SetIndexBuffer(2,Candle1);
	SetIndexBuffer(3,Candle2);				
	
	SetIndexStyle(0,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(1,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(2,DRAW_HISTOGRAM,0,CandleWidth);
	SetIndexStyle(3,DRAW_HISTOGRAM,0,CandleWidth);
	
   return(0);
  }
  
  int deinit()
  {
//----
 
//----
   return(0);
  }
   double RSI (int i = 0){return(iCustom(NULL, 0, "RSI-M30", Tf30_Rsi8_Per, Tf30_Rsi4_Per, Tf30_Rsi2_Per, 2, i));}
   double RSI2 (int i = 0){return(iCustom(NULL, 0, "RSI-M30", Tf30_Rsi8_Per, Tf30_Rsi4_Per, Tf30_Rsi2_Per, 1, i));}
      
   void SetCandleColor(int col, int i)
{
	double high,low,bodyHigh,bodyLow;

	
	
		bodyHigh = MathMax(Open[i],Close[i]);
		bodyLow  = MathMin(Open[i],Close[i]);
		high		= High[i];
		low		= Low[i];
	

	Bar1[i] = low;	Candle1[i] = bodyLow;
	Bar2[i] = low;	Candle2[i] = bodyLow;
	Bar1[i] = low;	Candle3[i] = bodyLow;
	Bar2[i] = low;	Candle4[i] = bodyLow;
	Bar1[i] = low;	Candle5[i] = bodyLow;
	Bar2[i] = low;	Candle6[i] = bodyLow;

	switch(col)
	{
		case 1: 	Bar1[i] = high;	Candle1[i] = bodyHigh;	break;
		case 2: 	Bar2[i] = high;	Candle2[i] = bodyHigh;	break;
		case 3: 	Bar1[i] = high;	Candle3[i] = bodyHigh;	break;
		case 4: 	Bar2[i] = high;	Candle4[i] = bodyHigh;	break;
		case 5: 	Bar1[i] = high;	Candle5[i] = bodyHigh;	break;
		case 6: 	Bar2[i] = high;	Candle6[i] = bodyHigh;	break;
	}
}

   int start()
{
	for(int i = MathMax(BARS-1-IndicatorCounted(),1); i>=0; i--)
	{
		double	rsi	= RSI(i);
		double	rsi2	= RSI2(i);
	
		if(rsi > rsi2)	SetCandleColor(1,i);
	   else	if(rsi <= rsi2) SetCandleColor(2,i);

  }
      	
   return(0);
  }